CLONE  ; CLONE (TM)	TAPE DUPLICATING PROGRAM
 ;
 ;ALL THE FOLLOWING IS COPYRIGHT (C) 1978,
 ;MUMFORD MICRO SYSTEMS, BOX 435, SUMMERLAND, CA 93067
 ;THE DISASSEMBLY WAS PROFORMED BY APPARAT'S "DISASSEM"
 ;THIS PROGRAM WAS KEYBOARDED, COMMENTED AND MODIFIED BY
 ;ADAM SACKS, P.O.BOX 395, HUNTINGTON, NY  11743
 ;
 ;	*ROM ROUTINES*
 POW	EQU	0000H	;(JUMP TO POWER-UP)
 SELECT	EQU	0212H	;(SELECT/TURN ON CSST)
 LEADER	EQU	0296H	;(SKIP LEADER)
 BYTIN	EQU	0235H	;(READ BYTE)
 CTOFF	EQU	01F8H	;(CSST OFF)
 BYTOUT	EQU	0264H	;(WRITE BYTE)
 AAA	EQU	022CH	;(???)
 BBB	EQU	0287H	;(???)
 BOOT	EQU	402DH	;(BOOT DOS)
 VIDEO	EQU	3C00H	;START OF SCREEN MEM.
 VIDEND	EQU	3FFFH	;END OF SCREEN MEM.
 STORE	EQU	5B89H	;START OF STORAGE ADD.
 	ORG	VIDEO
 	DEFM	'*****************************************'
 	ORG	VIDEO+40H
 	DEFM	'* CLONE      (TAPE DUPLICATION PROGRAM) *'
 	ORG	VIDEO+80H
 	DEFM	'* COPYRIGHT 1978, MUMFORD MICRO SYSTEMS *'
 	ORG	VIDEO+0C0H
 	DEFM	'*****************************************'
 	ORG	0BE00H;CHANGE THIS FOR OTHER MEM. SIZES
 BEGIN1	CALL	CLS
 HALF	DI
 DUMP	LD	A,(STORE)
 	CP	09H
 	CALL	Z,FILL6
 	LD	HL,DATA1
 	LD	IX,VIDEO+40H;POINT TO 2ND LINE
 LOOP1	LD	A,(HL)
 	CP	0H
 	JR	Z,BEGIN2
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	JR	LOOP1
 BEGIN2	LD	HL,DATA2
 	LD	IX,VIDEO+80H;POINT TO 3RD LINE
 LOOP2	LD	A,(HL)
 	CP	0H
 	JR	Z,BEGIN3
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	JR	LOOP2
 BEGIN3	LD	HL,DATA3
 	LD	IX,VIDEO+0C0H;POINT TO 4TH LINE
 LOOP3	LD	A,(HL)
 	CP	0H
 	JR	Z,BEGIN4
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	JR	LOOP3
 BEGIN4	LD	HL,DATA4
 	LD	IX,VIDEO+140H;POINT TO 6TH LINE
 LOOP4	LD	A,(HL)
 	CP	0H
 	JR	Z,INKEY
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	JR	LOOP4
 INKEY	LD	A,(3810H)
 	CP	01H
 	JR	Z,JUMP
 	CP	02H
 	JP	Z,ROUTE1
 	CP	04H
 	JP	Z,ROUTE2
 	CP	08H
 	JP	Z,ROUTE3
 	CP	10H
 	JP	Z,POW
 	JR	INKEY
 JUMP	CALL	CLS
 	EI
 	JP	BOOT
 ;ROUTINE #1, LOADING SYSTEM TAPES
 ROUTE1	CALL	CLS
 	CALL	CLRMEM
 	LD	HL,STORE
 	CALL	LEADER
 	LD	B,07H
 GEORGE	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	DEC	B
 	JR	NZ,GEORGE
 MARY	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	SUB	78H
 	JP	Z,BILLY
 	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	LD	B,A
 	CALL	AAA
 	LD	E,00H	;CLR E REG.
 	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	ADD	A,E
 	LD	E,A
 	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	ADD	A,E
 	LD	E,A
 MARK	CALL	BYTIN
 	LD	(HL),A
 	LD	(VIDEO+40H),A
 	INC	HL
 	ADD	A,E
 	LD	E,A
 	DEC	B
 	JP	NZ,MARK
 	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	SUB	E
 	JP	NZ,ERROR
 	JP	MARY
 BILLY	CALL	BYTIN
 	LD	(HL),A
 	INC	HL
 	CALL	BYTIN
 	LD	(HL),A
 	JP	KILDRV
 ;SUB-ROUTINE TO CLEAR SCREEN (CLS)
 CLS	LD	HL,VIDEO
 SPACE	LD	(HL),20H;LOAD 20H (SPACE) TO HL
 	INC	HL	;ADD 1 TO SCREEN MEM.
 	LD	A,H	;TRANSFER H TO A
 	SUB	40H	;SEE IF LINE DONE
 	JP	NZ,SPACE;IF NOT DO AGAIN
 	RET
 ;SUB-ROUTINE TO PUT "9"'S IN MEMORY 4589H - TOPMEM
 CLRMEM	LD	HL,STORE;SET UP HL FOR STORE ADD.
 PUT09	LD	(HL),09H;CLR THE HL ADD.
 	INC	HL	;ADD 1 TO STORE ADD.
 	LD	A,H	;TRANSFER H TO A
 	SUB	0BEH	;SEE IF MEM FILLED THROUGH 0BE00H
 	JP	NZ,PUT09;IF NOT DO AGAIN
 ;ROUTINE TO SEND "OK" MESSAGE TO SCREEN
 	LD	A,4FH
 	LD	(VIDEO),A
 	LD	A,4BH
 	LD	(VIDEO+01H),A
 	XOR	A
 	CALL	SELECT	;CSST ON
 	RET
 ;ROUTINE #2, LOADING DATA TAPES
 ROUTE2	CALL	CLS
 	CALL	CLRMEM
 	LD	HL,STORE
 	CALL	LEADER	;SKIP LEADER
 LOAD	CALL	BYTIN	;READ BYTE
 	LD	(HL),A	;STORE BYTE IN HL REG.
 	LD	(VIDEO+40H),A
 	LD	A,(3840H);CHECK INKEY MEM.
 	CP	01H	 ;CHECK IF 'ENTER'
 	JR	Z,KILDRV ;IF TRUE JP KILDRV
 	INC	HL
 	JR	LOAD	;CONTINUE LOAD
 ;ROUTINE #3, DUMPING EITHER TYPE OF TAPE
 ROUTE3	CALL	CLS
 	LD	A,00H
 	CALL	SELECT
 	CALL	BBB
 	LD	HL,STORE-1
 ADD1	INC	HL
 	LD	A,(HL)
 	LD	(VIDEO+40H),A
 	CALL	BYTOUT
 	SUB	09H
 	JP	NZ,ADD1
 	INC	HL
 	LD	A,(HL)
 	CALL	BYTOUT
 	SUB	09H
 	JR	NZ,ADD1
 	INC	HL
 	LD	A,(HL)
 	CALL	BYTOUT
 	SUB	09H
 	JP	NZ,ADD1
 	INC	HL
 	LD	A,(HL)
 	CALL	BYTOUT
 	SUB	09H
 	JP	NZ,ADD1
 	INC	HL
 	LD	A,(HL)
 	CALL	BYTOUT
 	SUB	09H
 	JP	NZ,ADD1
 KILDRV	CALL	CTOFF	;TURN OFF CSST
 DEBBIE	JP	BEGIN1
 ;ROUTINE TO RECOGNIZE A CHECKSUM ERROR
 ERROR	CALL	CTOFF
 	CALL	CLS
 	LD	HL,DATA5
 	LD	IX,VIDEO
 CJ7	LD	A,(HL)
 	CP	0H
 	JP	Z,HALF
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	JR	CJ7
 FILL6	LD	A,09H
 	LD	(STORE),A
 	LD	(STORE+1),A
 	LD	(STORE+2),A
 	LD	(STORE+3),A
 	LD	(STORE+4),A
 	LD	(STORE+5),A
 	RET
 DATA1	DEFM	'1=INPUT A SYSTEM TAPE'
 	DEFB	0H
 DATA2	DEFM	'2=INPUT A DATA TAPE'
 	DEFB	0H
 DATA3	DEFM	'3=OUTPUT EITHER TYPE OF TAPE'
 	DEFB	0H
 DATA4	DEFM	'? '
 	DEFB	5FH
 	DEFB	0H
 DATA5	DEFM	'BAD LOAD...  START OVER'
 	DEFB	0H
 	OR	A
 	END	BEGIN1
